## minimac4 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(minimac4 VERSION 1.0.0)

set(CMAKE_CXX_STANDARD 11)
execute_process(COMMAND date OUTPUT_VARIABLE DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND whoami OUTPUT_VARIABLE USER OUTPUT_STRIP_TRAILING_WHITESPACE)

add_definitions(-DVERSION="${PROJECT_VERSION}" -DUSER="${USER}" -DDATE="${DATE}")

find_package(OpenMP)
if (OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()



find_package(ZLIB REQUIRED)
find_library(STATGEN_LIBRARY StatGen)
add_executable(minimac4
        src/Analysis.cpp
        src/Analysis.h
        src/AnalysisChunks.cpp
        src/DosageData.cpp
        src/DosageData.h
        src/HaplotypeSet.cpp
        src/HaplotypeSet.h
        src/Imputation.cpp
        src/Imputation.h
        src/ImputationStatistics.cpp
        src/ImputationStatistics.h
        src/Main.cpp
        src/MarkovModel.cpp
        src/MarkovModel.h
        src/MarkovParameters.cpp
        src/MarkovParameters.h
        src/MyVariables.h
        src/Unique.cpp
        src/Unique.h
        src/Estimation.cpp
        src/Estimation.h)

target_link_libraries(minimac4 ${STATGEN_LIBRARY} ${ZLIB_LIBRARIES})

install(TARGETS minimac4 RUNTIME DESTINATION bin)

=== requirements.txt ===
statgen/libStatGen --cmake dep/libstatgen.cmake

=== debian/changelog ===
minimac4 (1.0.0-2) unstable; urgency=medium

  * Fix autopkgtest.
  * Add a patch to improve reproducible builds.
  * Standards-Version: 4.2.1 (no changes needed).

 -- Dylan Aïssi <bob.dybian@gmail.com>  Fri, 28 Sep 2018 18:04:57 +0200

minimac4 (1.0.0-1) unstable; urgency=low

  * Initial release. (Closes: #900764)

 -- Dylan Aïssi <bob.dybian@gmail.com>  Tue, 05 Jun 2018 22:17:26 +0200

=== debian/control ===
Source: minimac4
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11),
               cmake,
               zlib1g-dev,
               libstatgen-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/minimac4
Vcs-Git: https://salsa.debian.org/med-team/minimac4.git
Homepage: https://genome.sph.umich.edu/wiki/Minimac4

Package: minimac4
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Fast Imputation Based on State Space Reduction HMM
 Minimac4 is a lower memory and more computationally efficient implementation
 of "minimac2/3". It is an algorithm for genotypic imputation that works on
 phased genotypes (say from MaCH).
 .
 Minimac4 is designed to handle very large reference panels in a more
 computationally efficient way with no loss of accuracy. This algorithm
 analyzes only the unique sets of haplotypes in small genomic segments, thereby
 saving on time\-complexity, computational memory but no loss in degree of
 accuracy.

## minimac4 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,13 @@
 cmake_minimum_required(VERSION 3.2)
-project(minimac4 VERSION 1.0.0)
+project(minimac4 VERSION 1.0.2)
 
 set(CMAKE_CXX_STANDARD 11)
 execute_process(COMMAND date OUTPUT_VARIABLE DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process(COMMAND whoami OUTPUT_VARIABLE USER OUTPUT_STRIP_TRAILING_WHITESPACE)
 
 add_definitions(-DVERSION="${PROJECT_VERSION}" -DUSER="${USER}" -DDATE="${DATE}")
+
+set(CMAKE_FIND_LIBRARY_SUFFIXES ".a;${CMAKE_FIND_LIBRARY_SUFFIXES}") # Prefer libz.a when both are available
 
 find_package(OpenMP)
 if (OPENMP_FOUND)
@@ -43,3 +45,8 @@
 target_link_libraries(minimac4 ${STATGEN_LIBRARY} ${ZLIB_LIBRARIES})
 
 install(TARGETS minimac4 RUNTIME DESTINATION bin)
+
+set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
+set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
+set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
+include(CPack)

=== requirements.txt ===
zlib,http://zlib.net/zlib-1.2.11.tar.gz
statgen/libStatGen --cmake dep/libstatgen.cmake

=== debian/changelog ===
minimac4 (1.0.2-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:19:52 +0100

minimac4 (1.0.2-2) unstable; urgency=medium

  * Fix autopkgtest. (Closes: #943897)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 05 Nov 2019 21:31:52 +0100

minimac4 (1.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.4.1 (no changes needed).
  * Bump debhelper-compat to 12.
  * Add patch to use shared zlib.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 14 Oct 2019 22:52:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: minimac4
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Dylan Aïssi <bob.dybian@gmail.com>
+Uploaders: Dylan Aïssi <daissi@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                zlib1g-dev,
                libstatgen-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/minimac4
 Vcs-Git: https://salsa.debian.org/med-team/minimac4.git
 Homepage: https://genome.sph.umich.edu/wiki/Minimac4

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CPPFLAGS_MAINT_APPEND = -I/usr/include/libStatGen

%:
	dh $@

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/Minimac4-$1\.tar\.gz/ \
  https://github.com/statgen/Minimac4/tags .*/v?(\d\S+)\.tar\.gz

## minimac4 4.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,9 @@
 cmake_minimum_required(VERSION 3.2)
-project(minimac4 VERSION 1.0.2)
+project(minimac4 VERSION 1.0.3)
+
+if(NOT CMAKE_BUILD_TYPE)
+    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose build type (Debug|Release|RelWithDebInfo|MinSizeRel)" FORCE)
+endif()
 
 set(CMAKE_CXX_STANDARD 11)
 execute_process(COMMAND date OUTPUT_VARIABLE DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
@@ -14,8 +18,6 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
 endif()
-
-
 
 find_package(ZLIB REQUIRED)
 find_library(STATGEN_LIBRARY StatGen)

=== requirements.txt ===
zlib,https://zlib.net/fossils/zlib-1.2.11.tar.gz --hash md5:1c9f62f0778697a09d36121ead88e08e
statgen/libStatGen --cmake dep/libstatgen.cmake

=== debian/changelog ===
minimac4 (4.0.3-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Refresh patches.
  * d/minimac4.1: bump version, no changes in available arguments.
  * d/copyright: bump copyright year to 2022.
  * d/control: add myself to uploaders.

 -- Étienne Mollier <emollier@debian.org>  Sun, 26 Jun 2022 13:09:35 +0200

minimac4 (1.0.2-4) unstable; urgency=medium

  * Team upload.
  * Rebuild minimac4 against libstatgen1.  (Closes: #1000475)

 -- Étienne Mollier <emollier@debian.org>  Wed, 08 Dec 2021 20:37:16 +0100

minimac4 (1.0.2-3) unstable; urgency=medium

  * Team upload.
  * Rebuild minimac4 against new version of libstatgen
    Closes: #996409
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * watch file standard 4 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 11 Nov 2021 11:48:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,18 @@
 Source: minimac4
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Dylan Aïssi <daissi@debian.org>
+Uploaders: Dylan Aïssi <daissi@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                zlib1g-dev,
                libstatgen-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/minimac4
 Vcs-Git: https://salsa.debian.org/med-team/minimac4.git
 Homepage: https://genome.sph.umich.edu/wiki/Minimac4
+Rules-Requires-Root: no
 
 Package: minimac4
 Architecture: any

## minimac4 4.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(minimac4 VERSION 4.1.2)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose build type (Debug|Release|RelWithDebInfo|MinSizeRel)" FORCE)
endif()

set(CMAKE_CXX_STANDARD 11)

add_definitions(-DVERSION="${PROJECT_VERSION}")

set(CMAKE_FIND_LIBRARY_SUFFIXES ".a;${CMAKE_FIND_LIBRARY_SUFFIXES}") # Prefer libz.a when both are available

#find_package(OpenMP)
#if (OPENMP_FOUND)
#    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
#endif()


find_package(Threads)
find_library(OMPP_LIBRARY omp)
find_package(savvy REQUIRED)

add_executable(minimac4
        src/dosage_writer.cpp src/dosage_writer.hpp
        src/hidden_markov_model.cpp src/hidden_markov_model.hpp
        src/input_prep.cpp src/input_prep.hpp
        src/recombination.cpp src/recombination.hpp
        src/unique_haplotype.cpp src/unique_haplotype.hpp
        src/main.cpp)

target_link_libraries(minimac4 savvy ${OMPP_LIBRARY} Threads::Threads)

if(BUILD_TESTS)
    enable_testing()
    add_test(simple_test ${CMAKE_SOURCE_DIR}/test/simple-test.sh ${CMAKE_BINARY_DIR}/minimac4 m4_simple_test_output ${CMAKE_SOURCE_DIR}/test/input/ref_panel.vcf ${CMAKE_SOURCE_DIR}/test/input/tar_panel.vcf)
    add_test(haploid_and_diploid_test ${CMAKE_SOURCE_DIR}/test/simple-test.sh ${CMAKE_BINARY_DIR}/minimac4 m4_haploid_and_diploid_test_output ${CMAKE_SOURCE_DIR}/test/input/ref_panel_with_haploid_sample.vcf ${CMAKE_SOURCE_DIR}/test/input/tar_panel_with_haploid_sample.vcf)
endif()

install(TARGETS minimac4 RUNTIME DESTINATION bin)

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
include(CPack)

=== debian/changelog ===
minimac4 (4.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Build-Depends: libsavvy-dev, libomp-jonathonl-dev, libzstd-dev
  * Standards-Version: 4.6.2 (routine-update)
  * Rename autopkgtest script to run-unit-test
  * Switch on build tests provided upstream
  * Build-Depends bcftools needed for build tests
  * Adapt autopkgtest to build time test

 -- Andreas Tille <tille@debian.org>  Tue, 24 Jan 2023 20:01:52 +0100

## minimac4 4.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2)
-project(minimac4 VERSION 4.1.2)
+project(minimac4 VERSION 4.1.4)
 
 if(NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose build type (Debug|Release|RelWithDebInfo|MinSizeRel)" FORCE)
@@ -32,6 +32,9 @@
 
 target_link_libraries(minimac4 savvy ${OMPP_LIBRARY} Threads::Threads)
 
+add_custom_target(manuals
+                  COMMAND help2man --output "${CMAKE_BINARY_DIR}/minimac4.1" "${CMAKE_BINARY_DIR}/minimac4")
+
 if(BUILD_TESTS)
     enable_testing()
     add_test(simple_test ${CMAKE_SOURCE_DIR}/test/simple-test.sh ${CMAKE_BINARY_DIR}/minimac4 m4_simple_test_output ${CMAKE_SOURCE_DIR}/test/input/ref_panel.vcf ${CMAKE_SOURCE_DIR}/test/input/tar_panel.vcf)
@@ -39,6 +42,9 @@
 endif()
 
 install(TARGETS minimac4 RUNTIME DESTINATION bin)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/minimac4.1
+        DESTINATION share/man/man1
+        OPTIONAL)
 
 set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
 set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})

=== debian/changelog ===
minimac4 (4.1.4-1) unstable; urgency=medium

  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Thu, 20 Jul 2023 00:43:42 +0200

## minimac4 4.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2)
-project(minimac4 VERSION 4.1.4)
+project(minimac4 VERSION 4.1.5)
 
 if(NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose build type (Debug|Release|RelWithDebInfo|MinSizeRel)" FORCE)

=== debian/changelog ===
minimac4 (4.1.5-1) unstable; urgency=medium

  * New upstream version 4.1.5
  * d/salsa-ci.yml: disable build test on i386.
  * lzma.patch: declare forwarding not-needed.

 -- Étienne Mollier <emollier@debian.org>  Wed, 15 Nov 2023 17:09:11 +0100

## minimac4 4.1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2)
-project(minimac4 VERSION 4.1.5)
+project(minimac4 VERSION 4.1.6)
 
 if(NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose build type (Debug|Release|RelWithDebInfo|MinSizeRel)" FORCE)

=== requirements.txt ===
statgen/savvy@v2.1.0
jonathonl/omp@v1.0.0

=== debian/changelog ===
minimac4 (4.1.6-1) unstable; urgency=medium

  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Fri, 08 Dec 2023 13:14:00 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,14 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                zlib1g-dev,
-               libstatgen-dev
-Standards-Version: 4.6.1
+               libstatgen-dev,
+               libshrinkwrap-dev,
+               libsavvy-dev,
+               libomp-jonathonl-dev,
+               liblzma-dev,
+               libzstd-dev,
+               bcftools <!nocheck>
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/minimac4
 Vcs-Git: https://salsa.debian.org/med-team/minimac4.git
 Homepage: https://genome.sph.umich.edu/wiki/Minimac4

=== debian/rules ===
--- 
+++ 
@@ -6,3 +6,6 @@
 
 %:
 	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DBUILD_TESTS=ON

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, bcftools
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/Minimac4-$1\.tar\.gz/ \
  https://github.com/statgen/Minimac4/tags .*/v?(\d\S+)\.tar\.gz
